class ContestsController < ApplicationController
  before_action :set_contest, only: %i[ destroy edit show update ]

  def index
    @contests = current_user.contests
    @title = "Welcome #{current_user.username}!"
  end

  def show
    @title = @contest.name
  end

  def edit
    @title = "Edit contest settings"
  end

  def new
    @contest = Contest.new
    @title = "New jigsaw puzzle competition"
  end

  def create
    @contest = Contest.new(contest_params)
    @contest.user_id = current_user.id
    if @contest.save
      redirect_to @contest
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @contest.update(contest_params)
      redirect_to @contest
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
  end

  private

  def set_contest
    @contest = Contest.find(params[:id])
  end

  def contest_params
    params.expect(contest: [ :name ])
  end
end
